unit CRegistryStatusStringUnit;
//Basisklasse von String Einstellungen (User-Name etc.)

interface
uses windows,CRegistryStatusUnit,StdCtrls,Dialogs;

type CRegistryStatusString=class(CRegistryStatus)
  constructor CreateTEdit(ted:TEdit;TSta:TLabel);virtual;
  procedure Change;virtual;
 protected
  cEdi:TEdit;    //Control fr Eingabe
  cSta:TLabel;   //Control fr berschrift von Eingabe
  bIsOk:Boolean; //True when Wert gesetzt werden kann
  strCurStatus:String; //aktueller Wert
 end;


implementation
constructor CRegistryStatusString.CreateTEdit(ted:TEdit;TSta:TLabel);
begin
 cEdi:=TEd;
 cSta:=TSta;

 if bIsOk=true then begin //Key kann gelesen werden...
  CEdi.Enabled:=True;
  CEdi.Text:=QueryKeyString(strTMPKey);
  cSta.Enabled:=True;
 end
 else begin
  CEdi.Enabled:=False;
  CEdi.Text:='';
  cSta.enabled:=False;
 end;

 strCurStatus:=CEdi.Text;
end;

procedure CRegistryStatusString.Change;
var b:Boolean;
begin
 if strCurStatus<>CEdi.Text then begin
  b:=CreateKeyString(strTMPKey,CEdi.Text);
  if b=false then begin   //Change failed
   ShowSetError;
  end;
 end;
end;

end.
