unit CRegistryValuesUnit;
//kapselt ALLE anderen Registry-Eigenschaften
//die auf CRegStatus (oder Unterklassen) basieren

interface
uses Windows,
     ClassRgDosNameCharUnit,
     ClassRgAlwaysUnloadDLLUnit,
     ClassLnkFileWithArrowUnit,
     ClassPIFHasArrowUnit,
     ClassLnkWithTextUnit,
     ClassStartBannerUnit,
     ClassWinAnimateTaskbarUnit,
     ClassIconTitleWrapUnit,
     ClassTrashcanNameUnit,
     ClassOwnerNameUnit,
     ClassCompanyNameUnit,
     ClassShowMiniBMPUnit,
     ClassNoSaveDesktopUnit,
     ClassSetupSourcePathUnit,
     ClassSmoothScrollUnit,
     ClassBeepOnErrorsUnit,
     ClassLoginUserNameUnit,
     ClassClickHereToBeginUnit,
     ClassLogAppErrorUnit,
     ClassMoreRam4DosAppsUnit,
     ClassMiddleButtonIsDoubleUnit,
     ClassStartmenuShowDelayUnit,
     ClassPlayAudioCDsAutoUnit,
     ClassPlayDataCDsAutoUnit,
     ClassFontSmoothingUnit,
     ClassDragFullWindowsUnit,
     ClassUnInstallUnit,
     ClassScreensaverPWUnit,
     ClassMSPlusFakeUnit;

type
 CRegistryValues=class(TObject)
  constructor Create;
  destructor Destroy;override;
 public
  CRgDosNameChar:ClassRgDosNameChar;
  CRgAlwaysUnloadDLL:ClassRgAlwaysUnloadDLL;
  CLnkFileWithArrow:ClassLnkFileWithArrow;
  CPIFHasArrow:ClassPIFHasArrow;
  CLnkWithText:ClassLnkWithText;
  CStartBanner:ClassStartBanner;
  CWinAnimateTaskbar:ClassWinAnimateTaskbar;
  CIconTitleWrap:ClassIconTitleWrap;
  CShowMiniBMP:ClassShowMiniBMP;
  CNoSaveDesktop:ClassNoSaveDesktop;
  CSmoothScroll:ClassSmoothScroll;
  CBeepOnErrors:ClassBeepOnErrors;
  CClickHereToBegin:ClassClickHereToBegin;
  CLogAppError:ClassLogAppError;
  CMiddleButtonIsDouble:ClassMiddleButtonIsDouble;
  CPlayAudioCDsAuto:ClassPlayAudioCDsAuto;
  CPlayDataCDsAuto:ClassPlayDataCDsAuto;
  CFontSmoothing:ClassFontSmoothing;
  CDragFullWindows:ClassDragFullWindows;

  CTrashcanName:ClassTrashcanName;
  COwnerName:ClassOwnerName;
  CCompanyName:ClassCompanyName;
  CSetupSourcePath:ClassSetupSourcePath;
  CLoginUserName:ClassLoginUserName;
  CMoreRam4DosApps:ClassMoreRam4DosApps;
  CStartmenuShowDelay:ClassStartmenuShowDelay;

  CUnInstall:ClassUnInstall;

  CScreensaverPW:ClassScreensaverPW;
  CMSPlusFake:ClassMSPlusFake;
end;

implementation
uses MainWindowUnit; //damit auf die Controls zugegiffen werden kann

constructor CRegistryValues.Create;
begin
 CRgDosNameChar:=ClassRgDosNameChar.CreateBool(Pointer(FRM_MainWindow.chk_DOSNameNoTilde));
 CRgAlwaysUnloadDLL:=ClassRgAlwaysUnloadDLL.CreateBool(Pointer(FRM_MainWindow.chk_AlwaysUnloadDLL));
 CLnkFileWithArrow:=ClassLnkFileWithArrow.CreateBool(Pointer(FRM_MainWindow.chk_InFileGotArrow));
 CPIFHasArrow:=ClassPIFHasArrow.CreateBool(Pointer(FRM_MainWindow.chk_PiffilesWithArrow));
 CLnkWithText:=ClassLnkWithText.CreateBool(Pointer(FRM_MainWindow.chk_NewLnkWithText));
 CStartBanner:=ClassStartBanner.CreateBool(Pointer(FRM_MainWindow.chk_StartBanner));
 CWinAnimateTaskbar:=ClassWinAnimateTaskbar.CreateBool(Pointer(FRM_MainWindow.chk_WinTaskbarZoom));
 CIconTitleWrap:=ClassIconTitleWrap.CreateBool(Pointer(FRM_MainWindow.chk_IconTitleWrap));
 CShowMiniBMP:=ClassShowMiniBMP.CreateBool(Pointer(FRM_MainWindow.chk_ShowBMPIcons));
 CNoSaveDesktop:=ClassNoSaveDesktop.CreateBool(Pointer(FRM_MainWindow.chk_SaveDesktop));
 CSmoothScroll:=ClassSmoothScroll.CreateBool(Pointer(FRM_MainWindow.chk_SmoothScrolling));
 CBeepOnErrors:=ClassBeepOnErrors.CreateBool(Pointer(FRM_MainWindow.chk_BeepOnErrors));
 CClickHereToBegin:=ClassClickHereToBegin.CreateBool(Pointer(FRM_MainWindow.chk_ClickHereToBegin));
 CLogAppError:=ClassLogAppError.CreateBool(Pointer(FRM_MainWindow.chk_LogAppErrors));
 CMoreRam4DosApps:=ClassMoreRam4DosApps.CreateBool(Pointer(FRM_MainWindow.chk_MoreRam4Dos));
 CMiddleButtonIsDouble:=ClassMiddleButtonIsDouble.CreateBool(Pointer(FRM_MainWindow.chk_LogiDoubleClick));
 CPlayAudioCDsAuto:=ClassPlayAudioCDsAuto.CreateBool(Pointer(FRM_MainWindow.chk_AutoPlayAudioCD));
 CPlayDataCDsAuto:=ClassPlayDataCDsAuto.CreateBool(Pointer(FRM_MainWindow.chk_AutoPlayDataCDs));
 CFontSmoothing:=ClassFontSmoothing.CreateBool(Pointer(FRM_MainWindow.chk_FontSmoothing));
 CDragFullWindows:=ClassDragFullWindows.CreateBool(Pointer(FRM_MainWindow.chk_DragFullWindows));

 CTrashcanName:=ClassTrashcanName.CreateTEdit(Pointer(FRM_MainWindow.edi_TrashcanName),Pointer(FRM_MainWindow.sta_TrashcanName));
 COwnerName:=ClassOwnerName.CreateTEdit(Pointer(FRM_MainWindow.edi_UserName),Pointer(FRM_MainWindow.sta_UserName));
 CCompanyName:=ClassCompanyName.CreateTEdit(Pointer(FRM_MainWindow.edi_CompanyName),Pointer(FRM_MainWindow.sta_CompanyName));
 CSetupSourcePath:=ClassSetupSourcePath.CreateTEdit(Pointer(FRM_MainWindow.edi_WinSourcePath),Pointer(FRM_MainWindow.sta_WinSourcePath));
 CLoginUserName:=ClassLoginUserName.CreateTEdit(Pointer(FRM_MainWindow.edi_UserNameLogin),Pointer(FRM_MainWindow.sta_UserNameLogin));
 CStartmenuShowDelay:=ClassStartmenuShowDelay.CreateTEdit(Pointer(FRM_MainWindow.edi_StartMenuDelay),Pointer(FRM_MainWindow.sta_StartMenuDelay));

 CUnInstall:=ClassUnInstall.CreateListBox(Pointer(FRM_MainWindow.lst_Deinstall));

 CScreensaverPW:=ClassScreensaverPW.Create;
 CMSPlusFake:=ClassMSPlusFake.Create;
end;

destructor CRegistryValues.Destroy;
begin
 CRgDosNameChar.Free;
 CRgAlwaysUnloadDLL.Free;
 CLnkFileWithArrow.Free;
 CPIFHasArrow.Free;
 CLnkWithText.Free;
 CStartBanner.Free;
 CWinAnimateTaskbar.Free;
 CIconTitleWrap.Free;
 CShowMiniBMP.Free;
 CNoSaveDesktop.Free;
 CSmoothScroll.Free;
 CBeepOnErrors.Free;
 CClickHereToBegin.Free;
 CLogAppError.Free;
 CMoreRam4DosApps.Free;
 CMiddleButtonIsDouble.Free;
 CPlayAudioCDsAuto.Free;
 CPlayDataCDsAuto.Free;
 CFontSmoothing.Free;
 CDragFullWindows.Free;

 CTrashcanName.Free;
 COwnerName.Free;
 CCompanyName.Free;
 CSetupSourcePath.Free;
 CLoginUserName.Free;
 CStartmenuShowDelay.Free;

 CUnInstall.Free;

 CScreensaverPW.Free;
 CMSPlusFake.Free;
end;

end.
