unit ClassDriveIconUnit;
//kmmert sich um die Icons fr die Laufwerke (ber autorun.inf)
//da es nur dieses Object gibt, wre eine abstract-Class ziemlich
//sinnlos
//sorry fr die teilweise brutale kurzform, aber ich wollte endlich
//fertig werden
interface
uses windows,StdCtrls,IniFiles,SysUtils,Dialogs;

type ClassDriveIcon=class(TObject)
 constructor Create(IconFile:TEDit;sta_IconFile:TLabel;IconNumber:TEdit;sta_IconNumber:TLabel);
 destructor Destroy;
public
 procedure UpdateDrive(Drive:string);
 procedure ChangeIconFile;
 procedure ChangeIconNr;
 procedure Save;
private
 //controls
 cIconFile:TEdit;
 cIconFileSta:TLabel;
 cIconNr:TEdit;
 cIconNrsta:TLabel;

 //Vars
 bDriveIsOk:Boolean;
 strCurAutoStartFile:String;
 strIconFile:string;
 strIconNr:string;
private
 procedure ReadValues(Drive:string);
 procedure EnabledControls(Really:Boolean);
 function SlashString(Input:String;Part1:Boolean):string;
end;

implementation
constructor ClassDriveIcon.Create(IconFile:TEDit;sta_IconFile:TLabel;IconNumber:TEdit;sta_IconNumber:TLabel);
begin
 cIconFile:=IconFile;
 cIconFileSta:=sta_IconFile;
 cIconNr:=IconNumber;
 cIconNrSta:=sta_IconNumber;

 cIconFile.Text:='';
 cIconNr.Text:='';
 strCurAutoStartFile:='';
 strIconFile:='';
 strIconNr:='';
end;

destructor ClassDriveIcon.Destroy;
begin
end;

procedure ClassDriveIcon.UpdateDrive(Drive:string);
var s:string;
begin
 s:=Copy(Drive,1,1);
 ReadValues(s);
end;

procedure ClassDriveIcon.ChangeIconFile;
begin
 strIconFile:=cIconFile.Text;
end;

procedure ClassDriveIcon.ChangeIconNr;
var i:integer;
begin
 try
  i:=StrToInt(cIconNr.Text);
  if (i<0) or (i>999) then
   raise EConvertError.Create('Falsche Zahlen');
  strIconnr:=cIconNr.Text; 
 except
  MessageDlg('Bitte geben Sie einen Wert zwischen 1 und 999 ein.',mtError,[mbOK],0);
  cIconNr.Text:=strIconNr;
 end;
end;

procedure ClassDriveIcon.ReadValues(Drive:string);
var
 x:TIniFile;
 s:string;
begin
 try
  ChDir(Drive+':\');
  bDriveIsOk:=True;
  strCurAutoStartFile:=drive+':\autorun.inf';
  if FileExists(strCurAutoStartFile) then begin
   x:=TIniFile.Create(strCurAutoStartFile);
   s:=x.ReadString('autorun','Icon','');
   x.Free;

   strIconFile:=SlashString(s,True);
   strIconNr:=SlashString(s,False);
   cIconFile.text:=strIconFile;
   cIconNr.text:=strIconNr;
  end else begin //kein autorun.inf
   cIconFile.text:='';
   cIconNr.text:='';
  end;
  EnabledControls(True);

 except
  bDriveIsOk:=False;
  EnabledControls(False);
  MessageDlg('Das angegebene Laufwerk ist ungltig!',mtError,[mbOK],0);
 end;
end;

procedure ClassDriveIcon.EnabledControls(Really:Boolean);
begin
 cIconFile.Enabled:=Really;
 cIconNr.Enabled:=Really;
 cIconFileSta.Enabled:=Really;
 cIconNrSta.Enabled:=Really;
end;

function ClassDriveIcon.SlashString(Input:String;Part1:Boolean):string;
var
 s1,s2:string;
 i:integer;
begin
 s1:=Input;
 i:=0;
 while Pos(',',s1)<>0 do begin
  i:=Pos(',',s1);
  s1:=Copy(s1,Pos(',',s1)+1,length(s1)); //soll doch die Funktion mal nachdenken
 end;
 if Part1 then
  if i=0 then s2:=Input
  else s2:=Copy(Input,1,length(Input)-Length(s1)-1)
 else //Part2
  if i=0 then s2:=''
  else s2:=Copy(Input,length(Input)-Length(s1)+1,Length(input));

 SlashString:=s2;
end;

procedure ClassDriveIcon.Save;
var x:TIniFile;
begin
 if bDriveIsOk then begin
  if strIconFile='' then
   MessageDlg('Sie haben keine Icondatei (z.B. SHELL32.DLL) angegeben!',mtError,[mbOK],0)
  else begin
   try
    x:=TIniFile.Create(strCurAutoStartFile);
    if strIconNr='' then x.WriteString('AutoRun','Icon',strIconFile)
    else x.WriteString('AutoRun','Icon',strIconFile+','+strIconNr);
    x.Free;
   except
    x.Free;
    MessageDlg('Beim Schreiben der Datei ist ein Fehler aufgetreten! Mglicherweise ist das Laufwerk ein CD-ROM.',
                mtError,[mbOK],0);

   end;
  end;
 end;
end;

end.
